// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::TabStyle;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockStack")]
    pub struct DockStack(Object<ffi::DzlDockStack, ffi::DzlDockStackClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_dock_stack_get_type(),
    }
}

impl DockStack {
    pub const NONE: Option<&'static DockStack> = None;

    #[doc(alias = "dzl_dock_stack_new")]
    pub fn new() -> DockStack {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_dock_stack_new()).unsafe_cast() }
    }
}

impl Default for DockStack {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockStack>> Sealed for T {}
}

pub trait DockStackExt: IsA<DockStack> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_stack_get_edge")]
    #[doc(alias = "get_edge")]
    fn edge(&self) -> gtk::PositionType {
        unsafe { from_glib(ffi::dzl_dock_stack_get_edge(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_dock_stack_get_show_pinned_button")]
    #[doc(alias = "get_show_pinned_button")]
    fn shows_pinned_button(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_stack_get_show_pinned_button(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_stack_get_style")]
    #[doc(alias = "get_style")]
    fn style(&self) -> TabStyle {
        unsafe {
            from_glib(ffi::dzl_dock_stack_get_style(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_stack_set_edge")]
    fn set_edge(&self, edge: gtk::PositionType) {
        unsafe {
            ffi::dzl_dock_stack_set_edge(self.as_ref().to_glib_none().0, edge.into_glib());
        }
    }

    #[doc(alias = "dzl_dock_stack_set_show_pinned_button")]
    fn set_show_pinned_button(&self, show_pinned_button: bool) {
        unsafe {
            ffi::dzl_dock_stack_set_show_pinned_button(
                self.as_ref().to_glib_none().0,
                show_pinned_button.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_dock_stack_set_style")]
    fn set_style(&self, style: TabStyle) {
        unsafe {
            ffi::dzl_dock_stack_set_style(self.as_ref().to_glib_none().0, style.into_glib());
        }
    }

    #[doc(alias = "edge")]
    fn connect_edge_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_edge_trampoline<P: IsA<DockStack>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockStack,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockStack::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::edge\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_edge_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-pinned-button")]
    fn connect_show_pinned_button_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_pinned_button_trampoline<
            P: IsA<DockStack>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockStack,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockStack::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-pinned-button\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_pinned_button_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "style")]
    fn connect_style_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_style_trampoline<P: IsA<DockStack>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockStack,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockStack::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::style\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_style_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockStack>> DockStackExt for O {}

impl fmt::Display for DockStack {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockStack")
    }
}
